//--- K.I.LIB ---
// kl_str.h : string classes for K.I.LIB

#ifndef AFX_KISTR_H__1932CA2C_ACA6_4606_B57A_ACD0B7D1D35B__INCLUDED_
#define AFX_KISTR_H__1932CA2C_ACA6_4606_B57A_ACD0B7D1D35B__INCLUDED_

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
// kiStr : P

class kiStr
{
friend void kilib_startUp();

private: //-- O[oȏȂ ---------------------

	static void init();

public: //-- OC^[tFCX --------------------------

	// 2bytȅ(悤ȋC)
	static char* next( char* p )
		{ return p+st_lb[(*p)&0xff]; }
	static const char* next( const char* p )
		{ return p+st_lb[(*p)&0xff]; }
	static bool isLeadByte( char c )
		{ return st_lb[c&0xff]==2; }

	// 
	kiStr( int start_size = 100 );
	kiStr( const char* s, int min_size = 100 );
	explicit kiStr( const kiStr& s );

	// Zq
	kiStr& operator = ( const kiStr& );
	kiStr& operator = ( const char* s );
	kiStr& operator += ( const char* s );
	kiStr& operator += ( char c );
	bool operator == ( const char* s ) const;
	bool isSame( const char* s )       const;
	operator const char*()             const;
	int len()                          const;
	char operator[]( int i ) const
		{ return m_pBuf[i]; }
	void lower()
		{ ::CharLower(m_pBuf); }
	void upper()
		{ ::CharUpper(m_pBuf); }
	kiStr& setInt( int n, bool cm=false );

	// \[X烍[h
	kiStr& loadRsrc( UINT id );

protected: //-- hNX -----------------------------

	char* m_pBuf;
	int   m_ALen;

private: //--  -------------------------------------

	static char st_lb[256];

public:

	virtual ~kiStr();
};

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
// kiPath : pXL̏p֐t

class kiPath : public kiStr
{
public: //-- OC^[tFCX --------------------------

	// 
	kiPath() : kiStr( MAX_PATH ){}
	explicit kiPath( const char* s ) : kiStr( s, MAX_PATH ){}
	explicit kiPath( const kiStr& s ) : kiStr( s, MAX_PATH ){}
	explicit kiPath( const kiPath& s ) : kiStr( s, MAX_PATH ){}
	kiPath( int nPATH, bool bs = true ) : kiStr( MAX_PATH )
		{
			beSpecialPath( nPATH );
			if( nPATH != Exe_name )
				beBackSlash( bs );
		}

	// operator
	void operator = ( const char* s ){ kiStr::operator =(s); }

	// pX擾
	void beSpecialPath( int nPATH );
	enum { Win=0x1787, Sys, Tmp, Prg, Exe, Cur, Exe_name,
			Snd=CSIDL_SENDTO, Dsk=CSIDL_DESKTOP, Doc=CSIDL_PERSONAL };

	// ZpX
	void beShortPath();

	// Ō̃obNXbV
	void beBackSlash( bool add );

	// fBNĝ
	bool beDirOnly();
	// t@Cexceptgq̂
	void getBody( kiStr& str ) const;

	// Kwmkdir
	void mkdir();
	// Kwrmdir
	void remove();

	// hCu^Cv
	UINT getDriveType() const;

	// [static] fBNg܂܂ȂAt@Ĉݒo
	static const char* name( const char* str );
	// [static] Ō̊gqBNULL
	static const char* ext( const char* str );
	// [static] gqSBNULL
	static const char* ext_all( const char* str );
	// [static] bodyoB
	static void body( const char* str, char* buf );
	// [static] \ / ŏI邩ۂ
	static bool endwithyen( const char* str );

	// non-static-ver
	const char* name() const
		{ return name(m_pBuf); }
	const char* ext() const
		{ return ext(m_pBuf); }
	const char* ext_all() const
		{ return ext_all(m_pBuf); }
};

#endif
